[原创]Codeforces 344E Read Time [二分答案]【思维】

2016-09-30 13:43:05 Tabris_ 阅读数:312


博客爬取于2020-06-14 22:43:08
以下为正文

版权声明:本文为Tabris原创文章,未经博主允许不得私自转载。
https://blog.csdn.net/qq_33184171/article/details/52710814


题目链接:http://codeforces.com/contest/344/problem/E

--------------------------------------------.
E. Read Time
time limit per test1 second
memory limit per test256 megabytes
inputstandard input
outputstandard output
Mad scientist Mike does not use slow hard disks. His modification of a hard drive has not one, but n different heads that can read data in parallel.

When viewed from the side, Mike’s hard drive is an endless array of tracks. The tracks of the array are numbered from left to right with integers, starting with 1. In the initial state the i-th reading head is above the track number hi. For each of the reading heads, the hard drive’s firmware can move the head exactly one track to the right or to the left, or leave it on the current track. During the operation each head’s movement does not affect the movement of the other heads: the heads can change their relative order; there can be multiple reading heads above any of the tracks. A track is considered read if at least one head has visited this track. In particular, all of the tracks numbered h1, h2, …, hn have been read at the beginning of the operation.

Mike needs to read the data on m distinct tracks with numbers p1, p2, …, pm. Determine the minimum time the hard drive firmware needs to move the heads and read all the given tracks. Note that an arbitrary number of other tracks can also be read.

Input
The first line of the input contains two space-separated integers n, m (1 ≤ n, m ≤ 105) — the number of disk heads and the number of tracks to read, accordingly. The second line contains n distinct integers hi in ascending order (1 ≤ hi ≤ 1010, hi < hi + 1) — the initial positions of the heads. The third line contains m distinct integers pi in ascending order (1 ≤ pi ≤ 1010, pi < pi + 1) - the numbers of tracks to read.

Please, do not use the %lld specifier to read or write 64-bit integers in С++. It is recommended to use the cin, cout streams or the %I64d specifier.

Output
Print a single number — the minimum time required, in seconds, to read all the needed tracks.

Examples
input
3 4
2 5 6
1 3 6 8
output
2
input
3 3
1 2 3
1 2 3
output
0
input
1 2
165
142 200
output
81
Note
The first test coincides with the figure. In this case the given tracks can be read in 2 seconds in the following way:

during the first second move the 1-st head to the left and let it stay there;
move the second head to the left twice;
move the third head to the right twice (note that the 6-th track has already been read at the beginning).
One cannot read the tracks in 1 second as the 3-rd head is at distance 2 from the 8-th track.
--------------------------------------------.

题目大意:
就是有N个磁头 和M个要读取的位置
磁头每移动一格耗时1秒
问你最短多长时间 能够将这M个位置读取

解题思路:
首先二分答案
然后判断这个答案能不能满足
然后慢慢缩小区间 最后答案就出来了

判断的时候要采取贪心的策略
因为在判断的时候我们默认二分出来的就是答案
然后贪心 看一看在二分出来的那个答案中能不能满足题意
只要判断每个磁头走移动这些步最多能都读取几个位置
然后判断这些位置能不能被走完
走完就是成立了

判断的时候就是让每个磁头尽可能的像右走 (前提是想把左边需要读取的点都读取完毕)
详细的请看代码注释…

附本题代码
----------.

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
# include <bits/stdc++.h>
using namespace std;

# define INF 0x3f3f3f3f
# define pb push_back
# define abs(a) (a)>0?(a):-(a)
# define lalal puts("*******");

typedef long long int LL ;
/**********************************/
const LL MOD = 1e9+7;


int n,m;
LL a[101010],b[101010];

bool check(LL x)
{
int step=0;
LL s;
for(int i=0; i<n&&step<m; i++)
{
if(a[i]-b[step]>x) return false;
s=a[i];
if(b[step]<s)
{
s=max(s,x-(a[i]-b[step])+b[step]); //先向左走 把之前啊没有读取的位置给读取了
s=max(s,(x-(a[i]-b[step]))/2+a[i]); //先向右走尽可能远 然后走回去 把之前没有读取的位置给读取了
}
else s=x+a[i];
//s 记录的是 这个磁头 向右最远能够走到哪个位置
while(step<m&&b[step]<=s) step++;
}
if(step<m) return false;
return true;
}

int main()
{
while(~scanf("%d%d",&n,&m))
{
for(int i=0; i<n; i++)scanf("%I64d",&a[i]);
for(int i=0; i<m; i++)scanf("%I64d",&b[i]);
LL l=0,r=100000000000ll,mid;
//二分是对最终的答案二分的 每次判断这个答案能不能满足 以此不断的缩小区间。。
//二分的界限一定是小于数据范围10倍的
//其实最大界限只要abs(a[1]-b[1])*2+abs(a[i]-b[m-1])进行了 但是没什么必要 写起来还很累。。。。
while(l<r)
{
mid=(l+r)>>1;
if(check(mid)) r=mid;//如果满足的话就缩小上限
else l=mid+1;//不满足的话就缩小区间下限
}
printf("%I64d\n",r);
}
return 0;
}